diff --git a/typing/debug_slice.ml b/typing/debug_slice.ml
new file mode 100644
index 0000000..55b0611
--- /dev/null
+++ b/typing/debug_slice.ml
@@ -0,0 +1,990 @@
+(* open Misc *)
+(* open Path *)
+open Asttypes
+open Ast_helper
+
+(* open Types *)
+open Typedtree
+(* open Ctype *)
+(* open Format *)
+
+open Parsetree
+open Debug_core
+
+(* Size を payload の PStr に埋め込み *)
+(* Size n を my_size n にする *)
+let my_size n =
+  let attr = (* see Debug_core.Attr.of_size *)
+    {attr_name = mknoloc "size";
+     attr_payload = PPat (Pat.constant (Const.int n), None);
+     attr_loc = Location.none} in
+  let exp = Exp.construct (mknoloc (Longident.Lident "_my_size_")) None in
+  PStr ([Str.eval ~attrs:[attr] exp])
+
+(* Size ここまで *)
+
+type structure_cxt = (structure_item * Env.t) list -> structure -> structure
+
+(* go *)
+(* 'a context_t を引数に持つ関数を、最後に 'a 型で受け取る形にする。 *)
+(* かっこを減らせる, 'a 型の引数で再帰する関数に渡すときに便利。 *)
+let go f prefix env cxt x = f ((x, cxt), env, prefix)
+
+(* id : 'a -> 'a *)
+let id = fun x -> x
+
+(* ここから *)
+module type Go =
+  sig
+    type t
+    val go : unit -> t
+  end
+
+module type InitTop =
+  sig
+    type t = structure
+    val name : string
+    val context : ((structure_item * structure) * structure_cxt) context_t
+  end
+
+module type InitSlice =
+  sig
+    type t
+    (*    val f : t -> structure *)
+    val slice : t
+    val cxt : expr_context
+    val typed_set : ((t -> t) -> t -> structure) * Env.t (* item_cxt *)
+  end
+
+module type Init =
+  sig
+    type t
+    val env : Env.t
+  end
+
+module type Slicer =
+  sig
+    type t
+    val get : (t * (t -> t)) * ((t -> t) -> t -> structure) -> expr_context ->t
+  end
+
+module type MakeSlicer =
+sig
+  (* init を渡すと slice型 の Slicer が生成されるファンクタ *)
+  (* string でスライサの種類を指定する *)
+  type slice
+  module type Init = Init with type t = slice
+    module type Slicer = Slicer with type t = slice
+    module type Make = functor (_ : Init) -> Slicer
+    val get : (module InitSlice with type t = slice) -> string -> slice
+  end
+
+module Generate = struct
+
+    (* context_t の生成 *)
+    let rec context' structure env prefix = match structure with
+        [] -> failwith "TypeDebugger: Error: structure is well typed."
+      | s :: rest ->
+         try
+           let (_, _, _, env') = Typemod.type_structure env [s] in
+           context' rest env' ((s, env) :: prefix)
+         with _ ->
+           ((((s, []), fun _ x -> x), Empty), env, prefix)
+
+    (* init の生成 *)
+    let init (type s) env =
+      (module
+         struct
+           type t = s
+           let env = env
+         end : Init with type t = s)
+
+    let initTop name structure env =
+      (* Data.Infer.init name; *)
+      (module
+         struct
+           type t = structure
+           let name = name
+           let context = context' structure env []
+         end : InitTop)
+
+    let initSlice (type s) skeleton ((((f, slice), str_cxt), cxt), env, prefix) = 
+        let item_cxt' prefix str slice_cxt slice' =
+          str_cxt prefix (str @ f (slice_cxt slice')) in
+
+        (module
+           struct
+             type t = s
+             let f = f
+             let slice = slice
+             let cxt = cxt
+             let typed_set = match prefix with
+                 [] -> (item_cxt' prefix [], env)
+               | (s', env') :: prefix' ->
+                  try
+                    ignore (Typemod.type_structure env (f skeleton));
+                    (* □に置き換えて welltyped: *)
+                    (item_cxt' prefix [], env)
+                  with _ ->
+                    (* □に置き換えて illtyped: *)
+                    (item_cxt' prefix' [s'], env')
+           end : InitSlice with type t = s)
+
+    (* スライスを求める *)
+    let slice (type s) slice item_cxt cxt (module S : Slicer with type t = s) =
+      S.get ((slice, id), item_cxt) cxt
+
+    (* Slicer モジュールを返す *)
+    let slicer (type s) name skeleton context
+               (module M : MakeSlicer with type slice = s) =
+      (module
+         struct
+           type t = s
+           let go () =
+             let slice =
+               M.get (initSlice skeleton context) name in             
+             slice
+         end : Go with type t = s)
+
+    let f (type s) (module F : Go with type t = s) = F.go ()
+
+  end
+
+module ExprSlicer :
+sig
+  open Parsetree
+  val search : string -> bool
+  val top : string ->
+    (((expression -> structure) * expression) *
+     ((structure_item * Env.t) list -> structure_item list -> structure))
+      context_t -> expression
+end = struct
+  
+  module Make =
+  struct
+    type slice = expression
+    module type Slicer = Slicer with type t = expression
+    module type Init = Init with type t = expression
+    module type Make = functor (_ : Init) -> Slicer
+
+    let print = print_deb_exp
+    let term e = Size.Exp.reset 0 e
+    let hole e = term (hole_of_exp e)
+    let make_slicer (module M : Make) (module I : Init) = (module M (I) : Slicer)
+
+    module Slicer0 (I : Init) = struct
+      include I
+
+      let wrap_expr expr_cxt' expr_cxt expr =
+        expr_cxt' (expr_cxt expr)
+      let wrap_item item_cxt expr_cxt' expr_cxt expr =
+        item_cxt (wrap_expr expr_cxt' expr_cxt) expr
+
+      let dummy_apply expr es =
+        if List.exists (fun e -> e = hole e) es then []
+        else
+          [{expr with
+            pexp_desc =
+              Pexp_apply (hole expr, List.map (fun e -> (Nolabel, e)) es)}]
+
+      let abst sel e' e = match Desc.Exp.comp e' e with
+          1 -> if sel then e else hole e
+        | 0 -> e'
+        | _ -> if sel then hole e else e
+                                     
+      let make_expr expr e' =
+        Desc.Exp.map (abst false e') expr
+                         
+      let selected_expr expr expr_cxt' e' =
+        if Desc.Exp.comp e' expr < 0 then expr_cxt' e' else e'
+                                                                      
+      (* dummy apply *)
+      let getChildren'' expr = match expr.pexp_desc with
+        | Pexp_tuple es ->
+            dummy_apply expr es
+        | Pexp_array es ->
+            dummy_apply expr es
+        | Pexp_construct (_, Some {pexp_desc = Pexp_tuple es}) ->
+            dummy_apply expr es
+        | _ -> []
+  
+      (* □以外の子ノード全て *)
+      let getChildren' expr = match expr.pexp_desc with
+        | Pexp_construct (_, Some {pexp_desc = Pexp_tuple es}) ->
+            List.filter (fun e -> e <> hole e) es
+        | _ ->
+            Desc.Exp.fold (
+              fun acc e ->
+                if Size.Exp.comp e < 1 then e :: acc else acc
+            ) [] expr
+              
+      let getChildren expr = getChildren'' expr @ getChildren' expr
+            
+      let rec search (slices, expr_cxt, item_cxt, f) cxt = match slices with
+        | [] -> f ()
+        | first :: rest ->
+            if print_slice then
+              Format.fprintf ppf "@[  search: %a @]@."
+                print first;
+
+            if Data.typed env item_cxt expr_cxt first then
+              (* welltyped *)
+              search (rest, expr_cxt, item_cxt, f) cxt
+            else
+              (* illtyped *)
+              get ((expr_cxt first, id), item_cxt) cxt
+                
+      and get ((expr, expr_cxt), item_cxt) cxt =
+        
+        if print_slice then
+          Format.fprintf ppf "@[  get: %a @]@."
+            print expr;
+        
+        let children = getChildren expr in
+        
+        match expr.pexp_desc with
+        
+        | Pexp_construct (lid, Some ({pexp_desc = Pexp_tuple es} as expr')) ->
+            
+            (* Construct *)
+            let fold es' e' =
+              {expr with
+               pexp_desc =
+                 Pexp_construct (
+                   lid,
+                   Some {expr' with
+                         pexp_desc =
+                           Pexp_tuple (List.map (abst false e') es')})} in
+            let f () =
+              let slice =
+                let fold' es' e' = fold es' (term e') in
+                let es' =
+                  Desc.Exp.fold (
+                    fun es' e ->
+                      let slice =
+                        get' ((e, id), wrap_item item_cxt (fold' es')) cxt in
+                      List.map (
+                        fun e ->
+                          if Desc.Exp.comp slice e < 0 then e else slice) es'
+                  ) es expr' in
+                fold' es' Hole.exp in
+              wrap_expr expr_cxt term slice in
+            
+            (* search *)
+            search (
+              children,
+              wrap_expr expr_cxt (selected_expr expr (fold es)),
+              item_cxt, f) cxt
+              
+        | _ ->
+            
+            let f () =
+              let slice =
+                let item_cxt' = wrap_item item_cxt expr_cxt in
+                Desc.Exp.fold (
+                  fun expr' e ->
+                    let expr_cxt'' = make_expr expr' in
+                    let item_cxt'' = wrap_item item_cxt' expr_cxt'' in          
+                    get' ((e, id), item_cxt'') cxt |> expr_cxt''
+                ) expr expr in
+              wrap_expr expr_cxt term slice in
+            
+            (* search *)
+            search (
+              children,
+              wrap_expr expr_cxt (selected_expr expr (make_expr expr)),
+              item_cxt, f) cxt
+              
+      (* get' *)
+      and get' ((expr, expr_cxt), item_cxt) cxt =
+        if Desc.Exp.leaf expr then wrap_expr expr_cxt term expr
+        else get ((expr, expr_cxt), item_cxt) cxt
+
+    end
+
+
+
+    module SelectiveSlicer (S : sig val selector : bool end) (I : Init) = struct
+      include I
+
+      let rec search (child, sel, expr_cxt, slice_cxt) item_cxt cxt =
+
+        if print_slice then
+          Format.fprintf ppf "@[  search / abst %s: %a @]@."
+            (if sel then "expect" else "one")
+            print child;
+        
+        let sel' =
+          Data.typed env item_cxt (slice_cxt sel expr_cxt) child in
+        if sel' && sel then
+          (* welltyped : abst expect *)
+          search (child, false, expr_cxt, slice_cxt) item_cxt cxt
+            
+        else
+          let g pair = get (pair, item_cxt) cxt in
+          if sel' && Size.Exp.comp child = 0 then
+            (* welltyped : is1 *)
+            g (slice_cxt false expr_cxt (term child), id)
+              
+          else if sel' || sel then
+            (* welltyped : greater1 *)
+            (* illtyped : abst expect *)
+            g (child, slice_cxt sel expr_cxt)
+              
+          else
+            (* illtyped : abst one *)
+            g (slice_cxt sel id child , expr_cxt)
+              
+      and get ((expr, expr_cxt), item_cxt) cxt =
+
+        if print_slice then
+          Format.fprintf ppf "@[  get: %a @]@."
+            print expr;
+        
+        if Size.Exp.comp expr < 0 then
+          let (expr', slice_cxt) =
+            if S.selector then
+              Size.getChildSet expr
+            else
+              Size.getChildSet2 expr in
+          search (expr',
+                  slice_cxt true id expr' <> expr, expr_cxt,
+                  slice_cxt) item_cxt cxt
+        else
+          get' ((expr, expr_cxt), item_cxt) cxt
+
+      and get' ((expr, expr_cxt), item_cxt) cxt =
+        let slice = expr_cxt expr in
+        if Size.Exp.comp slice < 0 then
+          get ((slice, id), item_cxt) cxt
+        else
+          slice
+    end
+
+    module Slicer3 (I : Init) = struct
+      include I
+          
+      let rec resize expr =
+        if Desc.Exp.leaf expr then expr (* そのまま *)
+        else
+          let n_sum = ref 0 in
+          let expr' =
+            Desc.Exp.map (
+              fun e ->
+                let e' = resize e in
+                let n' = Size.Exp.get e' in
+                n_sum := !n_sum + n';
+                e'
+            ) expr in
+          if !n_sum = 0 then
+            (* expr も 0 になる *)
+            term expr'
+          else
+            Size.Exp.reset (!n_sum + 1) expr'
+              
+      let rec make_expr_cxt0 expr piv =
+        match (expr.pexp_desc, piv.pexp_desc) with
+        | (Pexp_apply (e, (_, e0) :: les0),
+           Pexp_apply (e1, les1)) when
+            e.pexp_desc = Hole.exp.pexp_desc
+            && e0.pexp_loc = piv.pexp_loc
+            && e1.pexp_desc = Hole.exp.pexp_desc->
+            
+            let attrs =
+              List.fold_left (
+                fun attrs' {attr_name = str; attr_payload; attr_loc} ->
+                  match (attrs', attr_payload) with
+                    ({attr_name = str'; attr_payload = PStr structure} :: rest,
+                     PStr structure')
+                    when str.txt = "app" && str'.txt = "app" ->
+                      (* mergeする *)
+                      let attr_payload = PStr (structure @ structure') in
+                      {attr_name = str'; attr_payload; attr_loc} :: rest
+                  | _ ->
+                      attrs'
+              ) piv.pexp_attributes expr.pexp_attributes in
+            
+            {expr with pexp_desc = Pexp_apply (e, les0 @ les1);
+                       pexp_attributes = attrs}
+        | _ ->
+            if print_slice then
+              Format.fprintf ppf "@[  make0(expr): %a @]@."
+                print_deb_exp expr;
+
+            if piv.pexp_loc = expr.pexp_loc then
+              piv
+            else
+              Desc.Exp.map (
+                fun e ->
+                  if Desc.Exp.internal e piv then
+                    make_expr_cxt0 e piv
+                  else
+                    e
+              ) expr
+                
+      let rec make_expr_cxt1 piv expr =
+        if piv = expr then
+          hole piv
+        else if piv.pexp_loc = expr.pexp_loc then
+          piv
+        else
+          Desc.Exp.map (
+            fun e ->
+              if Desc.Exp.internal e piv then
+                make_expr_cxt1 piv e
+              else
+                e
+          ) expr
+            
+      let dummy_apply expr es =
+        {expr with
+         pexp_desc =
+           Pexp_apply
+             (hole expr, List.map (fun e -> (Nolabel, e)) es)}
+        
+      
+      let rec make_expr_cxt2 piv expr =
+        if piv.pexp_loc = expr.pexp_loc then
+          piv
+        else
+          match expr.pexp_desc with
+          | Pexp_construct (_, Some {pexp_desc = Pexp_tuple es}) ->
+              make_dummy_apply_cxt es piv expr
+          | Pexp_tuple es ->
+              make_dummy_apply_cxt es piv expr
+          | Pexp_array es ->
+              make_dummy_apply_cxt es piv expr
+          | Pexp_record (les, eop) ->
+              let es' = match eop with
+                  None ->
+                    List.map (
+                      fun (_, e) -> make_expr_cxt2' piv e
+                    ) les
+                | Some e' ->
+                    List.map
+                      (make_expr_cxt2' piv)
+                      (e' :: List.map snd les) in
+              dummy_apply expr es'
+          | Pexp_ifthenelse (e1, e2, eop) ->
+              let es = e1 :: e2 ::
+                       match eop with None -> [] | Some e' -> [e'] in
+              let es' = List.map (make_expr_cxt2' piv) es in
+              dummy_apply expr es'
+                
+          | Pexp_apply (e, les)
+            when 0 < Size.Exp.get e
+              && not (Desc.Exp.internal e piv) ->
+              let expr' =
+                make_skeleton_apply_cxt ([], (Nolabel, e) :: les) piv expr in
+              if print_slice then
+                Format.fprintf ppf "@[  skeleton apply: %a @]@."
+                  print_deb_exp expr';
+              
+              make_expr_cxt2' piv {expr' with pexp_loc = expr.pexp_loc}
+                
+          | Pexp_apply (e, (_, {pexp_loc;
+                                pexp_attributes;
+                                pexp_desc =
+                                  Pexp_apply (e', (l0, e0) :: les0)}) :: les1)
+            when
+              (* 入れ子になっているが、pivは関数適用ではない *)
+              Desc.Exp.internal {skeleton' with pexp_loc = pexp_loc} piv && pexp_loc <> piv.pexp_loc
+              (* hole あるいは抽象化される式 *)
+              && (e.pexp_desc = Hole.exp.pexp_desc
+                  || (0 < Size.Exp.get e
+                      && not (Desc.Exp.internal e piv)))
+              && (e'.pexp_desc = Hole.exp.pexp_desc
+                  || (0 < Size.Exp.get e'
+                      && not (Desc.Exp.internal e' piv))) ->
+              
+              let expr' =
+                let les =
+                  List.filter (
+                    fun (_, e_) ->
+                      (* 抽象化できない式 or 既に抽象化された式を除外 *)
+                      e_.pexp_desc <> Hole.exp.pexp_desc
+                      && 0 = Size.Exp.get e_
+                  ) (les0 @ les1) in
+                
+                let attrs =
+                  List.fold_left (
+                    fun attrs' {attr_name = str; attr_payload; attr_loc} ->
+                      match (attrs', attr_payload) with
+                        ({attr_name = str'; attr_payload = PStr structure}
+                           :: rest,
+                         PStr structure')
+                        when str.txt = "app" && str'.txt = "app" ->
+                          (* mergeする *)
+                          let attr_payload = PStr (structure @ structure') in
+                          {attr_name = str'; attr_payload; attr_loc} :: rest
+                      | _ ->
+                          attrs'
+                  ) pexp_attributes expr.pexp_attributes in
+                Desc.Exp.map
+                  (make_expr_cxt2' piv)
+                  {expr
+                   with pexp_desc = Pexp_apply (Hole.exp, (l0, e0) :: les);
+                        pexp_attributes = attrs} in
+              
+              if print_slice then
+                Format.fprintf ppf "@[  nested apply: %a @]@."
+                  print_deb_exp expr';
+
+              make_expr_cxt2' piv expr'
+                
+          | _ ->
+              (* その他 *)
+              Desc.Exp.map (make_expr_cxt2' piv) expr
+                
+      and make_expr_cxt2' piv expr =
+        if Desc.Exp.internal expr piv then
+          (* 部分木の一部：再帰 *)
+          make_expr_cxt2 piv expr
+        else if Size.Exp.get expr = 0 then
+          (* 確定 *)
+          expr
+        else
+          (* 抽象化 *)
+          hole expr
+            
+      (* dummy apply の生成 *)
+      and make_dummy_apply_cxt es piv expr =
+        let expr' =
+          make_skeleton_apply_cxt
+            ([], List.map (fun e -> (Nolabel, e)) es) piv expr in
+        if print_slice then
+          Format.fprintf ppf "@[  dummy apply: %a @]@."
+            print_deb_exp expr';
+        make_expr_cxt2 piv expr'
+
+      and make_skeleton_apply_cxt (acc, les) piv expr = match les with
+        | [] ->
+            (* 元の関数適用 *)
+            let payload =
+              {attr_name = {txt = "app"; loc = expr.pexp_loc};
+               attr_payload = PStr [Str.eval (Desc.Exp.map_all (
+                   fun e -> {e with pexp_attributes = []}
+                 ) expr)];
+               attr_loc = Location.none } in
+            {expr with
+             pexp_desc =
+               Pexp_apply (hole expr, acc);
+             pexp_attributes =
+               payload :: expr.pexp_attributes}
+            
+        | (l, e) :: rest ->
+            let acc' =
+              let e' = make_expr_cxt2' piv e in
+              if e' = hole_of_exp e then
+                (* 抽象化される *)
+                acc
+              else
+                (* 抽象化されない *)
+                acc @ [(l, e')] in
+            make_skeleton_apply_cxt (acc', rest) piv expr
+              
+      let make_slice_cxt' slice expr = match slice.pexp_desc with
+          Pexp_construct (_, Some {pexp_desc = Pexp_tuple es})
+          when Desc.Exp.fold (
+              fun b e ->
+                if e <> slice && 0 = Size.Exp.get e then
+                  b
+                else if b then
+                  e = slice
+                else
+                  b
+            ) true expr ->
+            let slice' =
+              let es' =
+                List.filter (
+                  fun {pexp_desc} -> pexp_desc <> Hole.exp.pexp_desc
+                ) es in
+              dummy_apply slice es' in
+            
+            let expr' =
+              Desc.Exp.map (
+                fun e' ->
+                  if e' = slice then
+                    slice'
+                  else
+                    e'
+              ) expr in
+            
+            if print_slice then
+              Format.fprintf ppf "@[  skip expected : %a@]@."
+                print_deb_exp expr';
+            expr'
+        | _ ->
+            make_expr_cxt2 slice expr
+              
+      let make_slice_cxt expr sel f slice =
+        f (resize (
+            if sel then
+              make_expr_cxt1 slice expr
+            else
+              make_slice_cxt' slice expr))
+          
+      let rec search f (child, sel, expr_cxt, slice_cxt) item_cxt cxt =
+
+        let sel' =
+          (* 呼び出し時に時間を記録 *)
+          Data.typed env item_cxt (slice_cxt sel expr_cxt) child in
+        
+        if print_slice then
+          Format.fprintf ppf "@[  search / abst %s is %s @]@."
+            (if sel then "one" else "expect")
+            (if sel' then "welltyped" else "illtyped");
+
+        let expr' = slice_cxt sel expr_cxt child in
+        if sel' && sel && 0 = Size.Exp.get expr' then
+          f ()
+        else if sel' && sel then
+          search f (child, false, expr_cxt, slice_cxt) item_cxt cxt
+        else
+          let g pair = get (pair, item_cxt) cxt in
+          if sel then
+            (* illtyped : abst one *)
+            begin
+              if print_slice then
+                Format.fprintf ppf "@[illtyped one : %a@]@."
+                  print_deb_exp expr';
+              g (resize (slice_cxt sel id child), expr_cxt)
+            end
+          else if sel' = sel then
+            (* illtyped : abst expected *)
+            begin
+              if print_slice then
+                Format.fprintf ppf "@[illtyped expected : %a@]@."
+                  print_deb_exp expr';
+              g (child, make_expr_cxt0 expr')
+            end
+          else
+            f ()
+              
+      and pick m expr =
+        if Desc.Exp.leaf expr then
+          (* leaf の場合は、そのまま返す *)
+          expr
+        else
+          Desc.Exp.fold (
+            fun piv node ->
+              if Size.Exp.get node < 1 then
+                (* node が確定している *)
+                piv                        
+              else
+                let n' = Size.Exp.get piv in
+                let m1 = abs (m - Size.Exp.get node) and m2 = abs (m - n') in
+                match compare m1 m2 with
+                  1 -> piv (* piv の方が適切 *)
+                | 0 when
+                    Desc.Exp.fold (
+                      fun b e ->
+                        if b && e <> node then true
+                        else if b && e = hole_of_exp e then true
+                        else false (* node が piv の子ノード *)
+                    ) true piv ->
+                    piv
+                | _ ->
+                    match expr.pexp_desc with
+                    | Pexp_construct (_, Some ({pexp_desc = Pexp_tuple (e :: es)} as e0))
+                      when e0 = node ->
+                        let p = pick m e in
+                        List.fold_left (
+                          fun p' e' ->
+                            if Size.Exp.get p' = 0 then
+                              e'
+                            else if hole_of_exp e' = e' then
+                              p'
+                            else
+                              let p'' = pick m e' in
+                              if 0 < compare m1 (abs (m - Size.Exp.get p'')) then
+                                p''
+                              else
+                                p'
+                        ) p es
+                    | _ ->
+                        if print_slice then
+                          Format.fprintf ppf "@[pick (node) : %a@]@."
+                            print_deb_exp node;
+                        pick m node
+          ) expr expr
+            
+      and get ((expr, expr_cxt), item_cxt) cxt =
+        
+        if Size.Exp.get expr = 0 || Desc.Exp.leaf expr then
+          get' ((expr, expr_cxt), item_cxt) cxt
+        else
+          let piv =                  
+            let m = (1 + Size.Exp.get expr) / 2 in
+            pick m expr in
+          
+          let f () =
+            
+            let terminate () =
+              if print_slice then
+                Format.fprintf ppf "@[welltyped terminated : %a@]@."
+                  print_deb_exp piv;
+              resize (make_expr_cxt0 expr (term piv)) in
+            if Size.Exp.get piv = 1 then
+              (* piv is size 1 : terminated *)
+              get ((terminate (), expr_cxt), item_cxt) cxt
+            else
+              let child_cxt expr_cxt' expr' =
+                make_slice_cxt expr true expr_cxt (expr_cxt' expr') in
+              let item_cxt' expr_cxt' expr' =
+                item_cxt (child_cxt expr_cxt') expr' in
+              begin
+                if print_slice then
+                  Format.fprintf ppf "@[welltyped sub-slice : %a@]@."
+                    print_deb_exp piv;
+                let piv' =
+                  get ((piv, id), item_cxt') cxt in
+                get ((child_cxt id piv', expr_cxt), item_cxt) cxt
+              end in
+          
+          begin
+            if print_slice then
+              begin
+                Format.fprintf ppf "@[  get: %a @]@."
+                  print expr;
+                Format.fprintf ppf "@[  pivot: %a @]@."
+                  print piv;
+              end
+            else
+              Data.Infer.read expr.pexp_loc;
+            
+            search f (piv, true, expr_cxt, make_slice_cxt expr) item_cxt cxt
+          end
+          
+      and get' ((expr, expr_cxt), item_cxt) cxt =
+        let slice = resize (expr_cxt expr) in
+        if print_slice then
+          Format.fprintf ppf "@[  get': %a @]@."
+            print (expr_cxt expr);
+        
+        (* size が 0 になった時点で終了 *)
+        if Size.Exp.get slice = 0 then
+          slice
+        else
+          get ((slice, id), item_cxt) cxt
+            
+    end
+
+    (* list *)
+    (* スライサーリスト *)
+    let list : (string * (module Make)) list =
+      ["original", (module Slicer0);
+       "resize1", (module SelectiveSlicer (struct let selector = true end));
+       "resize2", (module SelectiveSlicer (struct let selector = false end));
+       "resize3", (module Slicer3)]
+      
+    (* search *)
+    (* スライサーを探す *)
+    let search name = List.exists (fun (name', _) -> name = name') list
+        
+    (* get_one *)
+    (* 1種類のスライサを起動 *)
+    let get_one (module S : InitSlice with type t = expression) (name, make) =
+      let open S in
+      if print_slice then
+        Format.fprintf ppf "@[[%s slicer] @]@." name;
+
+      (* スライスを求める *)
+      if not (Data.typed (snd typed_set) (fst typed_set) hole slice) then
+        hole slice (* expr が不要 *)
+      else if Desc.Exp.leaf slice then
+        term slice (* expr が必要かつ leaf *)
+      else
+        Generate.init (snd typed_set) (* その他 *)
+        |> make_slicer make
+        |> Generate.slice slice (fst typed_set) cxt
+
+    (* get_all *)
+    (* 全ての複数のスライサを起動 *)
+    let get_all init = List.map (get_one init) list
+        
+    (* get *)
+    (* 外部から呼び出される。スライスを求める関数。 *)
+    let get init name =
+      try
+        get_one init (name, List.assoc name list)
+      with
+        Not_found -> List.hd (get_all init)
+                       
+  end
+
+  let search = Make.search
+                 
+  (* top *)
+  (* 外部から呼び出される。スライサの入口 *)
+  let top name ((((expr_cxt, expr), structure_cxt), cxt), env, prefix) =
+    
+    (* 初期状態の生成 *)
+    let expr =
+      Data.init ((expr, cxt), env, prefix) in
+
+    Data.Infer.write [] expr false;
+    let time0 = Sys.time () in
+    let slice =
+      Generate.f (
+        Generate.slicer name Hole.exp
+          ((((expr_cxt, expr), structure_cxt), cxt), env, prefix)
+          (module Make : MakeSlicer with type slice = expression)) in
+    let time1 = Sys.time () in
+    Data.Infer.write [] slice true;
+
+    (* スライスの出力をしていない場合、データを記録する *)
+    if print_slice then
+      slice
+    else
+      Data.finally slice (time1 -. time0)
+end
+
+(* 共通部分 *)
+module Top (I : InitTop) =
+  struct
+    type t = structure
+
+    (* search *)
+    (* structure のスライスを1行ずつ求める。 *)
+    let rec search (str_cxt, prefix, slice_str) cxt = match prefix with
+        [] -> str_cxt [] slice_str
+      | (next_str, env) :: rest ->
+         go get rest env cxt ((next_str, slice_str), str_cxt)
+
+    (* get *)
+    (* 着目している行のスライスを求める。 *)
+    and get ((((item, slice_str), str_cxt), cxt), env, prefix) =
+      match item with
+        {pstr_desc = d; pstr_loc = loc} ->
+          (* item をスライシングして、slice_str を更新する。 *)
+          let slice_str' = match d with
+            | Pstr_eval (expr, _) ->
+                (* eval *)
+                (* expr;; *)
+                let eval_cxt e = (Str.eval ~loc e) :: slice_str in
+                go eval prefix env cxt
+                  (str_cxt, eval_cxt, expr)
+            | Pstr_value (flg, vs) when item <> hole_str ->
+                (* value *)
+                (* let (flg) P0=E0 and ... Pn=En *)
+                let value_cxt vs = (Str.value ~loc flg vs) :: slice_str in
+                go value prefix env cxt
+                  (str_cxt, value_cxt, go Desc.Vb.complete prefix env cxt vs)
+
+            | Pstr_module ({pmb_loc; pmb_name = name;
+                            pmb_expr = {pmod_loc;
+                                        pmod_attributes = [];
+                                        pmod_desc =
+                                          Pmod_structure (mod_str)}}) ->
+                (* module *)
+                (* module MODULENAME = struct ... end *)
+                let me_cxt str =
+                  Mod.structure
+                    ~loc:pmod_loc
+                    ~attrs:[{attr_name = mkloc "mod" loc;
+                             attr_payload = PStr mod_str;
+                             attr_loc = Location.none};
+                            {attr_name = mknoloc "size";
+                             attr_payload = my_size (List.length mod_str);
+                             attr_loc = Location.none}] str in
+                let mb_cxt str =
+                  Mb.mk ~loc:pmb_loc name (me_cxt str) in
+                let mod_cxt str =
+                  (Str.module_ ~loc (mb_cxt str)) :: slice_str in
+                go module_
+                  [] env cxt
+                  (mod_str,
+                   fun prefix' structure' ->
+                     mod_cxt (
+                       List.fold_left (
+                         fun str (s', _) ->
+                           s' :: str) structure' prefix'))
+            | _ ->
+                (* その他は特に何もしない *)
+                item :: slice_str in
+          
+          (* search に移動 *)
+          search (str_cxt, prefix, slice_str') cxt
+
+    (* Eval : (structure_cxt * (expression -> structure) * expression) context_t
+     -> structure *)
+    (* eval のスライシング *)
+    and eval (((str_cxt, eval_cxt, expr), cxt), env, prefix) =
+      let slice =
+        go get' prefix env cxt ((eval_cxt, expr), str_cxt) in
+
+      if print_slice then
+        Format.fprintf ppf "@[get_slice_eval: %a @]@."
+                       print_deb_strs (eval_cxt slice);
+      eval_cxt slice
+
+    (* value *)
+    (* value のスライシング *)
+    and value (((str_cxt, value_cxt, vs), cxt), env, prefix) = match vs with
+        [] -> value_cxt []
+      | vn :: rest ->
+         (* vn のスライスを求める *)
+         let value_cxt' e vs' = value_cxt ((Map.set_exp Map.v1 vn e) :: vs') in
+         let vb_cxt e = value_cxt' e rest in
+         let slice =
+           go get' prefix env cxt ((vb_cxt, vn.pvb_expr), str_cxt) in
+         if print_slice then
+           Format.fprintf ppf "@[get_slice_value: %a @]@."
+                          Pprintast.structure (value_cxt' (Meta.clean "all" slice) []);
+         go value prefix env cxt (str_cxt, value_cxt' slice, rest)
+
+    (* module *)
+    (* (structure_cxt * (structure -> structure) * structure) context_t
+     -> structure *)
+    (* module のスライシング *)
+    and module_ (((structure, structure_cxt), cxt), env, prefix) =
+      match structure with
+        [] -> search (structure_cxt, prefix, []) cxt
+      | s :: rest ->
+         try
+           (* rest のみ無視したモジュールで型がつくかどうかチェックする *)
+           ignore (
+               Typemod.type_structure
+                 env [List.hd (structure_cxt prefix [s])]);
+           (* prefix に積んで再帰 *)
+           go module_ ((s, env) :: prefix) env cxt (rest, structure_cxt)
+         with _ ->
+           (* モジュールの中で型エラー *)
+           go get prefix env cxt ((s, []), structure_cxt)
+
+    (* get' *)
+    (* Expression_slicing に行く *)
+    (* ひとつ前の行の環境があれば使う。なければ現在の環境を使う。 *)
+    and get' context = ExprSlicer.top I.name context
+
+    (* ここから呼び出す *)
+    let go () =
+      let structure = get I.context in
+      if Debug_core.on_file_output then Data.Slice.Exp.outputs ();
+
+      if ExprSlicer.search I.name then
+        (* アルゴリズムの指定があればそのまま返す *)
+        structure
+      else
+        (* それ以外ではデバッガの起動は不要 *)
+        failwith "Slicer: debug mode"
+
+  end
+(* ここまで：デバッグ用のスライス書き込み *)
+
+(* スライスのトップ *)
+let get_slice_top structure env =
+  Warnings.parse_options false "-A";
+
+  let (module I : InitTop) =
+    (* アルゴリズムの種類を環境変数で指定 *)
+    try
+      let name = Sys.getenv "DEBUGGER_SELECTED_SLICER" in
+      Generate.initTop name structure env
+    with
+    (* なければデフォルトの設定 *)
+      Not_found -> Generate.initTop "resize3" structure env in
+
+  (* スライサの処理に進む *)
+  Generate.f (module Top (I) : Go with type t = structure)
